#!/bin/bash
if [ -n "$(id | grep root)" ]; then
{
   zenity --question --width=200 --title="Configuració del perfil de ràdio" --text="Voleu iniciar la configuració del perfil de ràdio?"
      if [ "$?" != 0 ]; then
      {
         zenity --width=200 --info "Atenció" \
--text="Heu cancel·lat la configuració."
         exit 0
      }
      fi
   TEMPLATE_ICECAST=/usr/share/linkat/linkat-perfil-radio/template_icecast.xml
#
# PER SUBSTITUIR:
#
# _LOCATION_
# _PASSWORD_
# _HOSTNAME_
#

#
# _LOCATION_
# UBICACIÓ DEL SERVIDOR ICECAST2
#
  PASSWORD=""
  HOME_RADIO="/home-local/radio"
  zenity --question --width=200 --title="Selecció del servidor Icecast" --text="Voleu configurar un servidor Icecast local?"
  if [ "$?" != 1 ]; then
  {
     zenity --info --width=200 --text="Tot seguit es configurarà el servidor Icecast local. Si en algun moment no sabeu què respondre, deixeu la resposta predeterminada."
     LOCATION=""
     while [ "$LOCATION" = "" ]; do
        LOCATION=$(zenity --entry \
--title="Nom del servidor Icecast" \
--width=200 \
--text="Doneu un nom descriptiu al servidor Icecast\n(pot ser la ubicació de la màquina):" \
--entry-text "Escola")
        if [ "$?" = "1" ]; then
           exit 0
        fi
     done
#
# _PASSWORD_
#
# Contrasenya assignada a l'usuari source (canal: stream), i als canals següents:
# Canal: radio (usuari: radio)
# Canal: audio (usuari: audio)
# Canal: video (usuari: video)
#
# S'assigna la contrasenya també a:
# Sources log in with username 'source'
# Relays log in with username 'relay'
# Admin logs in with username 'admin'
#
   PASSWORD=""
   while [ "$PASSWORD" = "" ]; do
      PASSWORD=$(zenity --entry \
--title="Definició de la contrasenya" \
--width=200 \
--text="Establiu la contrasenya per al servidor Icecast:")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done
#
# _HOST_ICECAST_
#
# Nom de host que es fa servir per accedir al servidor
#
   HOST_ICECAST=""
   while [ "$HOST_ICECAST" = "" ]; do
      HOST_ICECAST=$(zenity --entry \
--title="Nom de host" \
--width=200 \
--text="Doneu un nom de host per al servidor Icecast:" \
--entry-text "localhost")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done
   MAX_LISTENERS=""
   while [ "$MAX_LISTENERS" = "" ]; do
      MAX_LISTENERS=$(zenity --entry \
--title="Nombre màxim d'oients" \
--width=200 \
--text="Establiu el nombre màxim d'oients simultanis \nper a cada canal del servidor Icecast:" \
--entry-text "100")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done
   TEMP_FILE=$(mktemp)
   cp $TEMPLATE_ICECAST $TEMP_FILE
   sed -i "s/_PASSWORD_/$PASSWORD/g;s/_LOCATION_/$LOCATION/g;s/_HOSTNAME_/$HOST_ICECAST/g;s/_MAX_LISTENERS_/$MAX_LISTENERS/g" $TEMP_FILE   
   if [ -e /etc/icecast2/icecast.xml ]; then
      cp /etc/icecast2/icecast.xml /etc/icecast2/icecast.xml.bak
   fi
   cp $TEMP_FILE /etc/icecast2/icecast.xml
   chown icecast2:icecast /etc/icecast2/icecast.xml
   chmod 660 /etc/icecast2/icecast.xml
   rm $TEMP_FILE
   if [ -n "$(grep ENABLE=false /etc/default/icecast2)" ]; then
      sed -i 's/ENABLE=false/ENABLE=true/g' /etc/default/icecast2
   fi
   systemctl restart icecast2
   zenity --width=200 --info "Informació" \
--text="S'ha realitzat la configuració del servidor Icecast.\n\r\
Estat del servidor Icecast: $(systemctl status icecast2 |grep Active\: |sed -e 's/^[[:space:]]*//' |cut -d " " -f 2)\n\r"
}
fi

zenity --info --width=200 --text="Tot seguit es configurarà el programa Butt per emetre àudio en directe a través del servidor Icecast."

#
# IP Servidor ICECAST2 - BUTT
#
   IP_ICECAST2=""
   while [ "$IP_ICECAST2" = "" ]; do
      IP_ICECAST2=$(zenity --entry \
--title="Adreça IP del servidor Icecast" \
--width=200 \
--text="Introduïu la IP o el nom de host del servidor Icecast:" \
--entry-text "127.0.0.1")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done

   if [ -n $HOST_ICECAST ]; then
      while [ "$HOST_ICECAST" = "" ]; do
         HOST_ICECAST=$(zenity --entry \
--title="Nom de host del servidor" \
--width=200 \
--text="Doneu un nom descriptiu per al servidor $IP_ICECAST2:" \
--entry-text "remot")
         if [ "$?" = "1" ]; then
            exit 0
         fi
      done
   fi

#
# BUTT: PORT
#

   PORT_ICECAST2=""
   while [ "$PORT_ICECAST2" = "" ]; do
      PORT_ICECAST2=$(zenity --entry \
--title="Port del servidor Icecast" \
--width=200 \
--text="Introduïu el port del servidor Icecast:" \
--entry-text "8000")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done
#
# BUTT: USUARI PER EMETRE ICECAST2
#
   USER_ICECAST2=""
   while [ "$USER_ICECAST2" = "" ]; do
      USER_ICECAST2=$(zenity --entry \
--title="Nom de l'usuari emissor" \
--width=200 \
--text="Indiqueu el nom d'usuari que pot emetre cap al servidor Icecast:" \
--entry-text "radio")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done

   if [ -n $PASSWORD ]; then
      while [ "$PASSWORD" = "" ]; do
         PASSWORD=$(zenity --entry \
--title="Contrasenya de l'usuari" \
--width=200 \
--text="Indiqueu la contrasenya de l'usuari $USER_ICECAST2:")
         if [ "$?" = "1" ]; then
            exit 0
         fi
      done
   fi

#
# BUTT: PUNT MUNTATGE ICECAST2
#
   MOUNT_ICECAST2=""
   while [ "$MOUNT_ICECAST2" = "" ]; do
      MOUNT_ICECAST2=$(zenity --entry \
--title="Canal d'emissió" \
--width=200 \
--text="Indiqueu el canal que s'utilitzarà per emetre:" \
--entry-text "radio")
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done

#
# Selecció locutor home-dona - radit
#
   zenity --info --width=200 --text="Tot seguit es configurarà la veu per a les locucions del programa Radit."
   VOICE=""
   while [ "$VOICE" = "" ]; do
      VOICE=$(zenity --list \
--title="Trieu una opció" \
--width=200 \
--height=200 \
--text="Seleccioneu la veu per a les locucions horàries i meteorològiques." \
--column="Veu" \
Pau \
Ona \
Personalitzada)
      if [ "$?" = "1" ]; then
         exit 0
      fi
   done
   if [ -L /usr/share/linkat/linkat-radit/radit/Hth ]; then
      rm /usr/share/linkat/linkat-radit/radit/Hth
   fi
   if [ $VOICE == "Pau" ]; then
      ln -s /usr/share/linkat/linkat-radit/radit/Hth.home /usr/share/linkat/linkat-radit/radit/Hth
   elif [ $VOICE == "Ona" ]; then
      ln -s /usr/share/linkat/linkat-radit/radit/Hth.dona /usr/share/linkat/linkat-radit/radit/Hth
   else
      CUSTOM_VOICE=$(zenity --file-selection --directory --filename=/home-local/radio/Multimèdia)
      if [ -n "$CUSTOM_VOICE" ]; then
         ln -s "$CUSTOM_VOICE" /usr/share/linkat/linkat-radit/radit/Hth
      else
         ln -s /usr/share/linkat/linkat-radit/radit/Hth.home /usr/share/linkat/linkat-radit/radit/Hth
      fi
   fi
   cp /usr/share/linkat/linkat-perfil-radio/template_butt $HOME_RADIO/.buttrc
   sed -i "s/_PASSWORD_/$PASSWORD/g;s/_HOSTNAME_/$HOST_ICECAST/g;s/_IP-ICECAST2_/$IP_ICECAST2/g;s/_USER_ICECAST2_/$USER_ICECAST2/g;s/_MOUNT_ICECAST2_/$MOUNT_ICECAST2/g;s/_PORT_ICECAST2_/$PORT_ICECAST2/g" $HOME_RADIO/.buttrc
   chown radio:radio $HOME_RADIO/.buttrc
   chmod 664 $HOME_RADIO/.buttrc
   zenity --width=200 --info "Informació" \
--text="El programa per emetre àudio en directe a través d'Icecast (Butt)\n\
s'ha configurat correctament.\n\r\
Adreça IP del servidor Icecast: $IP_ICECAST2\n\r"
}
else {

         zenity --width=200 --info "Atenció" \
--text="No sou usuari root / sudoer.\n\nS'ha cancel·lat la configuració."
}
fi
